package com.jz.common.utils;


import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Map;

public class EasyJsonUtils {

    public static Object getKeyJsonQuery(Map<?, ?> map, String jsonKey) {
        String[] arrs = jsonKey.split("\\.");
        Object obj = null;
        for (int i = 0; i < arrs.length; i++) {
            if (i == 0) {
                obj = handle(map, arrs[i]);
            } else {
                if (obj instanceof Map) {
                    obj = handle((Map<?, ?>) obj, arrs[i]);
                } else if (obj instanceof List) {
                    obj = handle((List<Map<?, ?>>) obj, arrs[i]);
                }
            }
        }
        return obj;
    }

    //解析map类型的对象
    public static Object handle(Map<?, ?> map, String key) {
        return map.get(key);
    }

    // 解析list类型的对象
    @SuppressWarnings("unchecked")
    public static Object handle(List<Map<?, ?>> listMap, String key) {
        List<Map<String, Object>> listMaps = new ArrayList<>();
        List<Object> lists = new ArrayList<>();
        // 这里用到了java8的一个新特性 stream 流
        listMap.stream().filter(e -> null != e.get(key)).forEach(e -> {
            //表示既不是map 又不是list类型
            if (!(e.get(key) instanceof Map<?, ?>) && !(e.get(key) instanceof List<?>)) {
                lists.add(e.get(key));
            } else {
                listMaps.addAll((Collection<? extends Map<String, Object>>) e.get(key));
            }
        });
        return lists.size() > 0 && !lists.isEmpty() ? lists : listMaps;
    }

    public static void main(String[] args) {
        String resp = "{\"schedule\":{\"cronExpression\":\"0 * 9 ? * *\",\"nextExecTime\":\"2017-04-01 09:00:00\",\"period\":\"null\",\"submitUser\":\"azkaban\",\"executionOptions\":{\"notifyOnFirstFailure\":false,\"notifyOnLastFailure\":false,\"failureEmails\":[],\"successEmails\":[],\"pipelineLevel\":null,\"queueLevel\":0,\"concurrentOption\":\"skip\",\"mailCreator\":\"default\",\"memoryCheck\":true,\"flowParameters\":{},\"failureAction\":\"FINISH_CURRENTLY_RUNNING\",\"failureEmailsOverridden\":false,\"successEmailsOverridden\":false,\"pipelineExecutionId\":null,\"disabledJobs\":[]},\"scheduleId\":\"3\",\"firstSchedTime\":\"2017-03-31 11:45:21\"}}";
    }

}
