package com.jz.dmp.azkaban.dao;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Param;

import com.jz.dmp.azkaban.entity.ProjectFlows;
import com.jz.dmp.modules.controller.azkaban.bean.ProjectFlowsDto;
import com.jz.dmp.modules.controller.bean.IndexProjAzkabanStatuDto;

/** mapper
 * @author ybz
 *
 */
public interface ProjectFlowsMapper {
	
	/**新增
     * @param projectFlows
     * @return
     * @throws Exception
     */
    public int insert(ProjectFlows projectFlows)throws Exception;

    /**选择性增加
     * @param projectFlows
     * @return
     * @throws Exception
     */
    public int insertSelective(ProjectFlows projectFlows)throws Exception;
    
    /**主键修改
     * @param projectFlows
     * @return
     * @throws Exception
     */
    public int updateByPrimaryKey(ProjectFlows projectFlows)throws Exception;

    /**选择性修改
     * @param projectFlows
     * @return
     * @throws Exception
     */
    public int updateByPrimaryKeySelective(ProjectFlows projectFlows)throws Exception;
    
    /**主键查询
     * @param projectId
     * @return
     * @throws Exception
     */
    public ProjectFlows selectByPrimaryKey(Integer projectId)throws Exception;

    /**主键删除
     * @param projectId
     * @return
     * @throws Exception
     */
    public int deleteByPrimaryKey(Integer projectId)throws Exception;
    
    /**主键软删除
     * @param projectId
     * @return
     * @throws Exception
     */
    public int softDeleteByPrimaryKey(Integer projectId)throws Exception;
    
    /**主键删除
     * @param projectId
     * @return
     * @throws Exception
     */
    public int delete(Map<String, Object> param)throws Exception;
    
    /**主键软删除
     * @param projectId
     * @return
     * @throws Exception
     */
    public int softDelete(Map<String, Object> param)throws Exception;

	/**条件查询
	 * @param param
	 * @return
	 * @throws Exception
	 */
	public List<ProjectFlowsDto> findList(Map<String, Object> param)throws Exception;

	/**主键查询
	 * @param projectId
	 * @return
	 * @throws Exception
	 */
	public ProjectFlowsDto findById(Integer projectId)throws Exception;

	/**批量新增
	 * @param projectFlowss
	 * @throws Exception
	 */
	public void insertBatch(List<ProjectFlows> projectFlowss)throws Exception;

	/**  
	* @Title: projAzkabanStatu  
	* @Description: TODO(统计任务运行状况)  
	* @param @return
	* @param @throws Exception    参数  
	* @return IndexProjAzkabanStatuDto    返回类型  
	* @throws  
	*/ 
	public IndexProjAzkabanStatuDto projAzkabanStatu(@Param("projectName")String projectName)throws Exception;
	
}
