package com.jz.dmp.modules.service;

import java.util.List;
import javax.servlet.http.HttpServletRequest;
import com.jz.common.bean.BaseBeanResponse;
import com.jz.common.bean.BaseResponse;
import com.jz.common.bean.PageInfoResponse;
import com.jz.dmp.modules.controller.bean.DmpOptLogBatch;
import com.jz.dmp.modules.controller.bean.DmpOptLogDto;
import com.jz.dmp.modules.controller.bean.DmpOptLogRequest;
import com.jz.dmp.modules.model.DmpOptLog;

/**
 * 操作日志表服务接口
 * @author ybz
 *
 */
public interface DmpOptLogService {

	/**条件分頁查询所有操作日志表
	 * @param dmpOptLogRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public PageInfoResponse<DmpOptLogDto> findListWithPage(DmpOptLogRequest dmpOptLogRequest, HttpServletRequest httpRequest)throws Exception;
	
	/**条件查询所有操作日志表
	 * @param dmpOptLogRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpOptLogDto> findList(DmpOptLogRequest dmpOptLogRequest, HttpServletRequest httpRequest)throws Exception;


	/**新增操作日志表
	 * @param dmpOptLog
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpOptLog> add(DmpOptLog dmpOptLog, HttpServletRequest httpRequest)throws Exception;
	
	/**主键查询操作日志表
	 * @param optId
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpOptLogDto> findById(Integer optId, HttpServletRequest httpRequest)throws Exception;

	/**修改操作日志表
	 * @param dmpOptLog
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpOptLog> edit(DmpOptLog dmpOptLog, HttpServletRequest httpRequest)throws Exception;
	
	/**新增或修改操作日志表
	 * @param dmpOptLog
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpOptLog> addOrEdit(DmpOptLog dmpOptLog, HttpServletRequest httpRequest)throws Exception;


	/**主键删除操作日志表
	 * @param optId
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse deleteById(Integer optId, HttpServletRequest httpRequest)throws Exception;
	
	/**主键软删除操作日志表
	 * @param optId
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse softDeleteById(Integer optId, HttpServletRequest httpRequest)throws Exception;
	
	/**条件删除操作日志表
	 * @param dmpOptLogRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse delete(DmpOptLogRequest dmpOptLogRequest, HttpServletRequest httpRequest)throws Exception;
	
	/**条件软删除操作日志表
	 * @param dmpOptLogRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse softDelete(DmpOptLogRequest dmpOptLogRequest, HttpServletRequest httpRequest)throws Exception;

	/**批量新增操作日志表
	 * @param dmpOptLogVo
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpOptLogBatch> addBatch(DmpOptLogBatch dmpOptLogBatch, HttpServletRequest httpRequest)throws Exception;

	/**  
	* @Title: deleteByIds  
	* @Description: TODO(根据主键批量删除)  
	* @param @param idList
	* @param @param httpRequest
	* @param @return
	* @param @throws Exception    参数  
	* @return BaseResponse    返回类型  
	* @throws  
	*/ 
	public BaseResponse deleteByIds(List<Integer> idList, HttpServletRequest httpRequest)throws Exception;

	/**  
	* @Title: softDeleteByIds  
	* @Description: TODO(根据主键批量软删除)  
	* @param @param idList
	* @param @param httpRequest
	* @param @return
	* @param @throws Exception    参数  
	* @return BaseResponse    返回类型  
	* @throws  
	*/ 
	public BaseResponse softDeleteByIds(List<Integer> idList, HttpServletRequest httpRequest)throws Exception;
	
	


}
