package com.jz.dmp.modules.service.impl;

import java.io.IOException;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import javax.servlet.http.HttpServletRequest;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.CollectionUtils;
import org.springframework.util.StringUtils;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.jz.common.bean.BaseBeanResponse;
import com.jz.common.bean.BaseResponse;
import com.jz.common.bean.PageInfoResponse;
import com.jz.common.constant.StatuConstant;
import com.jz.common.persistence.BaseService;
import com.jz.common.utils.CodeGeneratorUtils;
import com.jz.common.utils.GZIPUtils;
import com.jz.dmp.modules.controller.DataIntegration.bean.flow.FlowPro;
import com.jz.dmp.modules.controller.bean.DmpDevelopTaskHistoryDto;
import com.jz.dmp.modules.controller.bean.DmpDevelopTaskHistoryRequest;
import com.jz.dmp.modules.controller.bean.MyDmpDevelopTaskConverter;
import com.jz.dmp.modules.controller.bean.MyDmpDevelopTaskHistoryConverter;
import com.jz.dmp.modules.dao.DmpDevelopTaskDao;
import com.jz.dmp.modules.dao.DmpDevelopTaskHistoryMapper;
import com.jz.dmp.modules.model.DmpDevelopTask;
import com.jz.dmp.modules.model.DmpDevelopTaskHistory;
import com.jz.dmp.modules.service.DmpDevelopTaskHistoryService;
import com.jz.dmp.modules.service.FlowService;

/**
 * 任务历史版本服务的实现?
 * 
 * @author ybz
 *
 */
@Service("dmpDevelopTaskHistoryService")
public class DmpDevelopTaskHistoryServiceImpl extends BaseService implements DmpDevelopTaskHistoryService {

	private static Logger logger = LoggerFactory.getLogger(DmpDevelopTaskHistoryServiceImpl.class);

	@Autowired
	private DmpDevelopTaskHistoryMapper dmpDevelopTaskHistoryMapper;
	
	@Autowired
    private DmpDevelopTaskDao dmpDevelopTaskDao;
	
	@Autowired
    private FlowService flowService;

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * com.ycxc.vmts.service.DmpDevelopTaskHistoryService#findList(com.ycxc.vmts.controller.bas.
	 * bean.DmpDevelopTaskHistoryRequest, javax.servlet.http.HttpServletRequest)
	 */
	@Override
	public PageInfoResponse<DmpDevelopTaskHistoryDto> findListWithPage(DmpDevelopTaskHistoryRequest dmpDevelopTaskHistoryRequest, HttpServletRequest httpRequest)
			throws Exception {
		PageInfoResponse<DmpDevelopTaskHistoryDto> pageInfoResponse = new PageInfoResponse<>();

		Map<String, Object> param = new HashMap<>();
		//主键
		if (dmpDevelopTaskHistoryRequest.getId() != null) {
			param.put("id", dmpDevelopTaskHistoryRequest.getId());
		}
		//所属任务(关联任务主键)
		if (dmpDevelopTaskHistoryRequest.getTaskId() != null) {
			param.put("taskId", dmpDevelopTaskHistoryRequest.getTaskId());
		}
		//tree ID
		if (dmpDevelopTaskHistoryRequest.getTreeId() != null) {
			param.put("treeId", dmpDevelopTaskHistoryRequest.getTreeId());
		}
		//数据源ID
		if (dmpDevelopTaskHistoryRequest.getDatasourceId() != null) {
			param.put("datasourceId", dmpDevelopTaskHistoryRequest.getDatasourceId());
		}
		//任务类型
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getTaskType())) {
			param.put("taskType", dmpDevelopTaskHistoryRequest.getTaskType());
		}
		//类型
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getType())) {
			param.put("type", dmpDevelopTaskHistoryRequest.getType());
		}
		//调度类型
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getScheduleType())) {
			param.put("scheduleType", dmpDevelopTaskHistoryRequest.getScheduleType());
		}
		//是否已提交
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getIsSubmit())) {
			param.put("isSubmit", dmpDevelopTaskHistoryRequest.getIsSubmit());
		}
		//描述
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getTaskDesc())) {
			param.put("taskDesc", dmpDevelopTaskHistoryRequest.getTaskDesc());
		}
		//脚本
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getScript())) {
			param.put("script", dmpDevelopTaskHistoryRequest.getScript());
		}
		//flow_header
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getFlowHeader())) {
			param.put("flowHeader", dmpDevelopTaskHistoryRequest.getFlowHeader());
		}
		//flow_json
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getFlowJson())) {
			param.put("flowJson", dmpDevelopTaskHistoryRequest.getFlowJson());
		}
		//版本
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getVersion())) {
			param.put("version", dmpDevelopTaskHistoryRequest.getVersion());
		}
		//is_gziped
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getIsGziped())) {
			param.put("isGziped", dmpDevelopTaskHistoryRequest.getIsGziped());
		}
		//任务数据状态
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getTaskDataStatus())) {
			param.put("taskDataStatus", dmpDevelopTaskHistoryRequest.getTaskDataStatus());
		}
		//任务创建用户ID
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getTaskCreateUserId())) {
			param.put("taskCreateUserId", dmpDevelopTaskHistoryRequest.getTaskCreateUserId());
		}
		//任务创建时间起
		if (dmpDevelopTaskHistoryRequest.getTaskCreateTimeStart() != null) {
			param.put("taskCreateTimeStart", dmpDevelopTaskHistoryRequest.getTaskCreateTimeStart());
		}
		//任务创建时间止
		if (dmpDevelopTaskHistoryRequest.getTaskCreateTimeEnd() != null) {
			param.put("taskCreateTimeEnd", dmpDevelopTaskHistoryRequest.getTaskCreateTimeEnd());
		}
		//任务修改用户ID
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getTaskUpdateUserId())) {
			param.put("taskUpdateUserId", dmpDevelopTaskHistoryRequest.getTaskUpdateUserId());
		}
		//任务修改时间起
		if (dmpDevelopTaskHistoryRequest.getTaskUpdateTimeStart() != null) {
			param.put("taskUpdateTimeStart", dmpDevelopTaskHistoryRequest.getTaskUpdateTimeStart());
		}
		//任务修改时间止
		if (dmpDevelopTaskHistoryRequest.getTaskUpdateTimeEnd() != null) {
			param.put("taskUpdateTimeEnd", dmpDevelopTaskHistoryRequest.getTaskUpdateTimeEnd());
		}
		//备注
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getRemark())) {
			param.put("remark", dmpDevelopTaskHistoryRequest.getRemark());
		}
		//数据状态(0：删除，1，未删除)
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getDataStatus())) {
			param.put("dataStatus", dmpDevelopTaskHistoryRequest.getDataStatus());
		}
		//创建用户ID
		if (dmpDevelopTaskHistoryRequest.getCreateUserId() != null) {
			param.put("createUserId", dmpDevelopTaskHistoryRequest.getCreateUserId());
		}
		//创建时间起
		if (dmpDevelopTaskHistoryRequest.getCreateTimeStart() != null) {
			param.put("createTimeStart", dmpDevelopTaskHistoryRequest.getCreateTimeStart());
		}
		//创建时间止
		if (dmpDevelopTaskHistoryRequest.getCreateTimeEnd() != null) {
			param.put("createTimeEnd", dmpDevelopTaskHistoryRequest.getCreateTimeEnd());
		}
		//修改用户ID
		if (dmpDevelopTaskHistoryRequest.getUpdateUserId() != null) {
			param.put("updateUserId", dmpDevelopTaskHistoryRequest.getUpdateUserId());
		}
		//修改时间起
		if (dmpDevelopTaskHistoryRequest.getUpdateTimeStart() != null) {
			param.put("updateTimeStart", dmpDevelopTaskHistoryRequest.getUpdateTimeStart());
		}
		//修改时间止
		if (dmpDevelopTaskHistoryRequest.getUpdateTimeEnd() != null) {
			param.put("updateTimeEnd", dmpDevelopTaskHistoryRequest.getUpdateTimeEnd());
		}

		PageHelper.startPage(dmpDevelopTaskHistoryRequest.getPageNum(), dmpDevelopTaskHistoryRequest.getPageSize());
		List<DmpDevelopTaskHistoryDto> list = dmpDevelopTaskHistoryMapper.findList(param);
		PageInfo<DmpDevelopTaskHistoryDto> pageInfo = new PageInfo<>(list);

		pageInfoResponse.setCode(StatuConstant.SUCCESS_CODE);
		pageInfoResponse.setMessage("查询成功");
		pageInfoResponse.setData(pageInfo);
		return pageInfoResponse;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * com.ycxc.vmts.service.DmpDevelopTaskHistoryService#findList(com.ycxc.vmts.controller.bas.
	 * bean.DmpDevelopTaskHistoryRequest, javax.servlet.http.HttpServletRequest)
	 */
	@Override
	public BaseBeanResponse<DmpDevelopTaskHistoryDto> findList(DmpDevelopTaskHistoryRequest dmpDevelopTaskHistoryRequest, HttpServletRequest httpRequest)
			throws Exception {
		BaseBeanResponse<DmpDevelopTaskHistoryDto> baseBeanResponse = new BaseBeanResponse<>();

		Map<String, Object> param = new HashMap<>();
		//主键
		if (dmpDevelopTaskHistoryRequest.getId() != null) {
			param.put("id", dmpDevelopTaskHistoryRequest.getId());
		}
		//所属任务(关联任务主键)
		if (dmpDevelopTaskHistoryRequest.getTaskId() != null) {
			param.put("taskId", dmpDevelopTaskHistoryRequest.getTaskId());
		}
		//tree ID
		if (dmpDevelopTaskHistoryRequest.getTreeId() != null) {
			param.put("treeId", dmpDevelopTaskHistoryRequest.getTreeId());
		}
		//数据源ID
		if (dmpDevelopTaskHistoryRequest.getDatasourceId() != null) {
			param.put("datasourceId", dmpDevelopTaskHistoryRequest.getDatasourceId());
		}
		//任务类型
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getTaskType())) {
			param.put("taskType", dmpDevelopTaskHistoryRequest.getTaskType());
		}
		//类型
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getType())) {
			param.put("type", dmpDevelopTaskHistoryRequest.getType());
		}
		//调度类型
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getScheduleType())) {
			param.put("scheduleType", dmpDevelopTaskHistoryRequest.getScheduleType());
		}
		//是否已提交
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getIsSubmit())) {
			param.put("isSubmit", dmpDevelopTaskHistoryRequest.getIsSubmit());
		}
		//描述
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getTaskDesc())) {
			param.put("taskDesc", dmpDevelopTaskHistoryRequest.getTaskDesc());
		}
		//脚本
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getScript())) {
			param.put("script", dmpDevelopTaskHistoryRequest.getScript());
		}
		//flow_header
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getFlowHeader())) {
			param.put("flowHeader", dmpDevelopTaskHistoryRequest.getFlowHeader());
		}
		//flow_json
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getFlowJson())) {
			param.put("flowJson", dmpDevelopTaskHistoryRequest.getFlowJson());
		}
		//版本
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getVersion())) {
			param.put("version", dmpDevelopTaskHistoryRequest.getVersion());
		}
		//is_gziped
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getIsGziped())) {
			param.put("isGziped", dmpDevelopTaskHistoryRequest.getIsGziped());
		}
		//任务数据状态
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getTaskDataStatus())) {
			param.put("taskDataStatus", dmpDevelopTaskHistoryRequest.getTaskDataStatus());
		}
		//任务创建用户ID
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getTaskCreateUserId())) {
			param.put("taskCreateUserId", dmpDevelopTaskHistoryRequest.getTaskCreateUserId());
		}
		//任务创建时间起
		if (dmpDevelopTaskHistoryRequest.getTaskCreateTimeStart() != null) {
			param.put("taskCreateTimeStart", dmpDevelopTaskHistoryRequest.getTaskCreateTimeStart());
		}
		//任务创建时间止
		if (dmpDevelopTaskHistoryRequest.getTaskCreateTimeEnd() != null) {
			param.put("taskCreateTimeEnd", dmpDevelopTaskHistoryRequest.getTaskCreateTimeEnd());
		}
		//任务修改用户ID
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getTaskUpdateUserId())) {
			param.put("taskUpdateUserId", dmpDevelopTaskHistoryRequest.getTaskUpdateUserId());
		}
		//任务修改时间起
		if (dmpDevelopTaskHistoryRequest.getTaskUpdateTimeStart() != null) {
			param.put("taskUpdateTimeStart", dmpDevelopTaskHistoryRequest.getTaskUpdateTimeStart());
		}
		//任务修改时间止
		if (dmpDevelopTaskHistoryRequest.getTaskUpdateTimeEnd() != null) {
			param.put("taskUpdateTimeEnd", dmpDevelopTaskHistoryRequest.getTaskUpdateTimeEnd());
		}
		//备注
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getRemark())) {
			param.put("remark", dmpDevelopTaskHistoryRequest.getRemark());
		}
		//数据状态(0：删除，1，未删除)
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getDataStatus())) {
			param.put("dataStatus", dmpDevelopTaskHistoryRequest.getDataStatus());
		}
		//创建用户ID
		if (dmpDevelopTaskHistoryRequest.getCreateUserId() != null) {
			param.put("createUserId", dmpDevelopTaskHistoryRequest.getCreateUserId());
		}
		//创建时间起
		if (dmpDevelopTaskHistoryRequest.getCreateTimeStart() != null) {
			param.put("createTimeStart", dmpDevelopTaskHistoryRequest.getCreateTimeStart());
		}
		//创建时间止
		if (dmpDevelopTaskHistoryRequest.getCreateTimeEnd() != null) {
			param.put("createTimeEnd", dmpDevelopTaskHistoryRequest.getCreateTimeEnd());
		}
		//修改用户ID
		if (dmpDevelopTaskHistoryRequest.getUpdateUserId() != null) {
			param.put("updateUserId", dmpDevelopTaskHistoryRequest.getUpdateUserId());
		}
		//修改时间起
		if (dmpDevelopTaskHistoryRequest.getUpdateTimeStart() != null) {
			param.put("updateTimeStart", dmpDevelopTaskHistoryRequest.getUpdateTimeStart());
		}
		//修改时间止
		if (dmpDevelopTaskHistoryRequest.getUpdateTimeEnd() != null) {
			param.put("updateTimeEnd", dmpDevelopTaskHistoryRequest.getUpdateTimeEnd());
		}

		List<DmpDevelopTaskHistoryDto> list = dmpDevelopTaskHistoryMapper.findList(param);

		baseBeanResponse.setCode(StatuConstant.SUCCESS_CODE);
		baseBeanResponse.setMessage("查询成功");
		baseBeanResponse.setDatas(list);
		return baseBeanResponse;
	}


	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * com.ycxc.vmts.service.DmpDevelopTaskHistoryService#add(com.ycxc.vmts.entity.DmpDevelopTaskHistory,
	 * javax.servlet.http.HttpServletRequest)
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public BaseBeanResponse<DmpDevelopTaskHistory> add(DmpDevelopTaskHistory dmpDevelopTaskHistory, HttpServletRequest httpRequest) throws Exception {
		BaseBeanResponse<DmpDevelopTaskHistory> baseBeanResponse = new BaseBeanResponse<>();

		// 创建人
		dmpDevelopTaskHistory.setCreateUserId(getHttpRequestUserId(httpRequest));
		// 创建时间
		dmpDevelopTaskHistory.setCreateTime(new Date());
		
		dmpDevelopTaskHistoryMapper.insertSelective(dmpDevelopTaskHistory);

		baseBeanResponse.setCode(StatuConstant.SUCCESS_CODE);
		baseBeanResponse.setMessage("新增成功");
		baseBeanResponse.setData(dmpDevelopTaskHistory);

		return baseBeanResponse;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * com.ycxc.vmts.service.DmpDevelopTaskHistoryService#edit(com.ycxc.vmts.entity.DmpDevelopTaskHistory,
	 * javax.servlet.http.HttpServletRequest)
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public BaseBeanResponse<DmpDevelopTaskHistory> edit(DmpDevelopTaskHistory dmpDevelopTaskHistory, HttpServletRequest httpRequest) throws Exception {
		BaseBeanResponse<DmpDevelopTaskHistory> baseBeanResponse = new BaseBeanResponse<>();

		// 修改人
		dmpDevelopTaskHistory.setUpdateUserId(getHttpRequestUserId(httpRequest));
		// 修改时间
		dmpDevelopTaskHistory.setUpdateTime(new Date());

		dmpDevelopTaskHistoryMapper.updateByPrimaryKeySelective(dmpDevelopTaskHistory);

		baseBeanResponse.setCode(StatuConstant.SUCCESS_CODE);
		baseBeanResponse.setMessage("修改成功");
		baseBeanResponse.setData(dmpDevelopTaskHistory);

		return baseBeanResponse;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * com.ycxc.vmts.service.DmpDevelopTaskHistoryService#findById(com.ycxc.vmts.controller.bas.
	 * bean.DmpDevelopTaskHistoryRequest, javax.servlet.http.HttpServletRequest)
	 */
	@Override
	public BaseBeanResponse<DmpDevelopTaskHistoryDto> findById(Integer id, HttpServletRequest httpRequest)
			throws Exception {
		BaseBeanResponse<DmpDevelopTaskHistoryDto> baseBeanResponse = new BaseBeanResponse<>();

		DmpDevelopTaskHistoryDto dmpDevelopTaskHistoryDto = dmpDevelopTaskHistoryMapper.findById(id);

		baseBeanResponse.setCode(StatuConstant.SUCCESS_CODE);
		baseBeanResponse.setMessage("查询成功");
		baseBeanResponse.setData(dmpDevelopTaskHistoryDto);

		return baseBeanResponse;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * com.ycxc.vmts.service.DmpDevelopTaskHistoryService#deleteById(com.ycxc.vmts.controller.bas.
	 * bean.DmpDevelopTaskHistoryRequest, javax.servlet.http.HttpServletRequest)
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public BaseResponse deleteById(Integer id, HttpServletRequest httpRequest) throws Exception {
		BaseResponse baseResponse = new BaseResponse();

		dmpDevelopTaskHistoryMapper.deleteByPrimaryKey(id);

		baseResponse.setCode(StatuConstant.SUCCESS_CODE);
		baseResponse.setMessage("删除成功");

		return baseResponse;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * com.ycxc.vmts.service.DmpDevelopTaskHistoryService#deleteById(com.ycxc.vmts.controller.bas.
	 * bean.DmpDevelopTaskHistoryRequest, javax.servlet.http.HttpServletRequest)
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public BaseResponse softDeleteById(Integer id, HttpServletRequest httpRequest) throws Exception {
		BaseResponse baseResponse = new BaseResponse();

		dmpDevelopTaskHistoryMapper.softDeleteByPrimaryKey(id);

		baseResponse.setCode(StatuConstant.SUCCESS_CODE);
		baseResponse.setMessage("软删除成功");

		return baseResponse;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * com.ycxc.vmts.service.DmpDevelopTaskHistoryService#deleteById(com.ycxc.vmts.controller.bas.
	 * bean.DmpDevelopTaskHistoryRequest, javax.servlet.http.HttpServletRequest)
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public BaseResponse delete(DmpDevelopTaskHistoryRequest dmpDevelopTaskHistoryRequest, HttpServletRequest httpRequest) throws Exception {
		BaseResponse baseResponse = new BaseResponse();

		Map<String, Object> param = new HashMap<>();
		//主键
		if (dmpDevelopTaskHistoryRequest.getId() != null) {
			param.put("id", dmpDevelopTaskHistoryRequest.getId());
		}
		//所属任务(关联任务主键)
		if (dmpDevelopTaskHistoryRequest.getTaskId() != null) {
			param.put("taskId", dmpDevelopTaskHistoryRequest.getTaskId());
		}
		//tree ID
		if (dmpDevelopTaskHistoryRequest.getTreeId() != null) {
			param.put("treeId", dmpDevelopTaskHistoryRequest.getTreeId());
		}
		//数据源ID
		if (dmpDevelopTaskHistoryRequest.getDatasourceId() != null) {
			param.put("datasourceId", dmpDevelopTaskHistoryRequest.getDatasourceId());
		}
		//任务类型
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getTaskType())) {
			param.put("taskType", dmpDevelopTaskHistoryRequest.getTaskType());
		}
		//类型
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getType())) {
			param.put("type", dmpDevelopTaskHistoryRequest.getType());
		}
		//调度类型
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getScheduleType())) {
			param.put("scheduleType", dmpDevelopTaskHistoryRequest.getScheduleType());
		}
		//是否已提交
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getIsSubmit())) {
			param.put("isSubmit", dmpDevelopTaskHistoryRequest.getIsSubmit());
		}
		//描述
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getTaskDesc())) {
			param.put("taskDesc", dmpDevelopTaskHistoryRequest.getTaskDesc());
		}
		//脚本
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getScript())) {
			param.put("script", dmpDevelopTaskHistoryRequest.getScript());
		}
		//flow_header
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getFlowHeader())) {
			param.put("flowHeader", dmpDevelopTaskHistoryRequest.getFlowHeader());
		}
		//flow_json
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getFlowJson())) {
			param.put("flowJson", dmpDevelopTaskHistoryRequest.getFlowJson());
		}
		//版本
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getVersion())) {
			param.put("version", dmpDevelopTaskHistoryRequest.getVersion());
		}
		//is_gziped
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getIsGziped())) {
			param.put("isGziped", dmpDevelopTaskHistoryRequest.getIsGziped());
		}
		//任务数据状态
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getTaskDataStatus())) {
			param.put("taskDataStatus", dmpDevelopTaskHistoryRequest.getTaskDataStatus());
		}
		//任务创建用户ID
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getTaskCreateUserId())) {
			param.put("taskCreateUserId", dmpDevelopTaskHistoryRequest.getTaskCreateUserId());
		}
		//任务创建时间起
		if (dmpDevelopTaskHistoryRequest.getTaskCreateTimeStart() != null) {
			param.put("taskCreateTimeStart", dmpDevelopTaskHistoryRequest.getTaskCreateTimeStart());
		}
		//任务创建时间止
		if (dmpDevelopTaskHistoryRequest.getTaskCreateTimeEnd() != null) {
			param.put("taskCreateTimeEnd", dmpDevelopTaskHistoryRequest.getTaskCreateTimeEnd());
		}
		//任务修改用户ID
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getTaskUpdateUserId())) {
			param.put("taskUpdateUserId", dmpDevelopTaskHistoryRequest.getTaskUpdateUserId());
		}
		//任务修改时间起
		if (dmpDevelopTaskHistoryRequest.getTaskUpdateTimeStart() != null) {
			param.put("taskUpdateTimeStart", dmpDevelopTaskHistoryRequest.getTaskUpdateTimeStart());
		}
		//任务修改时间止
		if (dmpDevelopTaskHistoryRequest.getTaskUpdateTimeEnd() != null) {
			param.put("taskUpdateTimeEnd", dmpDevelopTaskHistoryRequest.getTaskUpdateTimeEnd());
		}
		//备注
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getRemark())) {
			param.put("remark", dmpDevelopTaskHistoryRequest.getRemark());
		}
		//数据状态(0：删除，1，未删除)
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getDataStatus())) {
			param.put("dataStatus", dmpDevelopTaskHistoryRequest.getDataStatus());
		}
		//创建用户ID
		if (dmpDevelopTaskHistoryRequest.getCreateUserId() != null) {
			param.put("createUserId", dmpDevelopTaskHistoryRequest.getCreateUserId());
		}
		//创建时间起
		if (dmpDevelopTaskHistoryRequest.getCreateTimeStart() != null) {
			param.put("createTimeStart", dmpDevelopTaskHistoryRequest.getCreateTimeStart());
		}
		//创建时间止
		if (dmpDevelopTaskHistoryRequest.getCreateTimeEnd() != null) {
			param.put("createTimeEnd", dmpDevelopTaskHistoryRequest.getCreateTimeEnd());
		}
		//修改用户ID
		if (dmpDevelopTaskHistoryRequest.getUpdateUserId() != null) {
			param.put("updateUserId", dmpDevelopTaskHistoryRequest.getUpdateUserId());
		}
		//修改时间起
		if (dmpDevelopTaskHistoryRequest.getUpdateTimeStart() != null) {
			param.put("updateTimeStart", dmpDevelopTaskHistoryRequest.getUpdateTimeStart());
		}
		//修改时间止
		if (dmpDevelopTaskHistoryRequest.getUpdateTimeEnd() != null) {
			param.put("updateTimeEnd", dmpDevelopTaskHistoryRequest.getUpdateTimeEnd());
		}

		dmpDevelopTaskHistoryMapper.delete(param);

		baseResponse.setCode(StatuConstant.SUCCESS_CODE);
		baseResponse.setMessage("删除成功");

		return baseResponse;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * com.ycxc.vmts.service.DmpDevelopTaskHistoryService#deleteById(com.ycxc.vmts.controller.bas.
	 * bean.DmpDevelopTaskHistoryRequest, javax.servlet.http.HttpServletRequest)
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public BaseResponse softDelete(DmpDevelopTaskHistoryRequest dmpDevelopTaskHistoryRequest, HttpServletRequest httpRequest) throws Exception {
		BaseResponse baseResponse = new BaseResponse();

		Map<String, Object> param = new HashMap<>();
		//主键
		if (dmpDevelopTaskHistoryRequest.getId() != null) {
			param.put("id", dmpDevelopTaskHistoryRequest.getId());
		}
		//所属任务(关联任务主键)
		if (dmpDevelopTaskHistoryRequest.getTaskId() != null) {
			param.put("taskId", dmpDevelopTaskHistoryRequest.getTaskId());
		}
		//tree ID
		if (dmpDevelopTaskHistoryRequest.getTreeId() != null) {
			param.put("treeId", dmpDevelopTaskHistoryRequest.getTreeId());
		}
		//数据源ID
		if (dmpDevelopTaskHistoryRequest.getDatasourceId() != null) {
			param.put("datasourceId", dmpDevelopTaskHistoryRequest.getDatasourceId());
		}
		//任务类型
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getTaskType())) {
			param.put("taskType", dmpDevelopTaskHistoryRequest.getTaskType());
		}
		//类型
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getType())) {
			param.put("type", dmpDevelopTaskHistoryRequest.getType());
		}
		//调度类型
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getScheduleType())) {
			param.put("scheduleType", dmpDevelopTaskHistoryRequest.getScheduleType());
		}
		//是否已提交
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getIsSubmit())) {
			param.put("isSubmit", dmpDevelopTaskHistoryRequest.getIsSubmit());
		}
		//描述
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getTaskDesc())) {
			param.put("taskDesc", dmpDevelopTaskHistoryRequest.getTaskDesc());
		}
		//脚本
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getScript())) {
			param.put("script", dmpDevelopTaskHistoryRequest.getScript());
		}
		//flow_header
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getFlowHeader())) {
			param.put("flowHeader", dmpDevelopTaskHistoryRequest.getFlowHeader());
		}
		//flow_json
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getFlowJson())) {
			param.put("flowJson", dmpDevelopTaskHistoryRequest.getFlowJson());
		}
		//版本
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getVersion())) {
			param.put("version", dmpDevelopTaskHistoryRequest.getVersion());
		}
		//is_gziped
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getIsGziped())) {
			param.put("isGziped", dmpDevelopTaskHistoryRequest.getIsGziped());
		}
		//任务数据状态
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getTaskDataStatus())) {
			param.put("taskDataStatus", dmpDevelopTaskHistoryRequest.getTaskDataStatus());
		}
		//任务创建用户ID
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getTaskCreateUserId())) {
			param.put("taskCreateUserId", dmpDevelopTaskHistoryRequest.getTaskCreateUserId());
		}
		//任务创建时间起
		if (dmpDevelopTaskHistoryRequest.getTaskCreateTimeStart() != null) {
			param.put("taskCreateTimeStart", dmpDevelopTaskHistoryRequest.getTaskCreateTimeStart());
		}
		//任务创建时间止
		if (dmpDevelopTaskHistoryRequest.getTaskCreateTimeEnd() != null) {
			param.put("taskCreateTimeEnd", dmpDevelopTaskHistoryRequest.getTaskCreateTimeEnd());
		}
		//任务修改用户ID
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getTaskUpdateUserId())) {
			param.put("taskUpdateUserId", dmpDevelopTaskHistoryRequest.getTaskUpdateUserId());
		}
		//任务修改时间起
		if (dmpDevelopTaskHistoryRequest.getTaskUpdateTimeStart() != null) {
			param.put("taskUpdateTimeStart", dmpDevelopTaskHistoryRequest.getTaskUpdateTimeStart());
		}
		//任务修改时间止
		if (dmpDevelopTaskHistoryRequest.getTaskUpdateTimeEnd() != null) {
			param.put("taskUpdateTimeEnd", dmpDevelopTaskHistoryRequest.getTaskUpdateTimeEnd());
		}
		//备注
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getRemark())) {
			param.put("remark", dmpDevelopTaskHistoryRequest.getRemark());
		}
		//数据状态(0：删除，1，未删除)
		if (!StringUtils.isEmpty(dmpDevelopTaskHistoryRequest.getDataStatus())) {
			param.put("dataStatus", dmpDevelopTaskHistoryRequest.getDataStatus());
		}
		//创建用户ID
		if (dmpDevelopTaskHistoryRequest.getCreateUserId() != null) {
			param.put("createUserId", dmpDevelopTaskHistoryRequest.getCreateUserId());
		}
		//创建时间起
		if (dmpDevelopTaskHistoryRequest.getCreateTimeStart() != null) {
			param.put("createTimeStart", dmpDevelopTaskHistoryRequest.getCreateTimeStart());
		}
		//创建时间止
		if (dmpDevelopTaskHistoryRequest.getCreateTimeEnd() != null) {
			param.put("createTimeEnd", dmpDevelopTaskHistoryRequest.getCreateTimeEnd());
		}
		//修改用户ID
		if (dmpDevelopTaskHistoryRequest.getUpdateUserId() != null) {
			param.put("updateUserId", dmpDevelopTaskHistoryRequest.getUpdateUserId());
		}
		//修改时间起
		if (dmpDevelopTaskHistoryRequest.getUpdateTimeStart() != null) {
			param.put("updateTimeStart", dmpDevelopTaskHistoryRequest.getUpdateTimeStart());
		}
		//修改时间止
		if (dmpDevelopTaskHistoryRequest.getUpdateTimeEnd() != null) {
			param.put("updateTimeEnd", dmpDevelopTaskHistoryRequest.getUpdateTimeEnd());
		}

		dmpDevelopTaskHistoryMapper.softDelete(param);

		baseResponse.setCode(StatuConstant.SUCCESS_CODE);
		baseResponse.setMessage("软删除成功");

		return baseResponse;
	}

	/**
	 *批量删除
	 */
	@Override
	@Transactional(rollbackFor=Exception.class)
	public BaseResponse deleteByIds(List<Integer> idList, HttpServletRequest httpRequest) throws Exception {
		BaseResponse baseResponse = new BaseResponse();

		dmpDevelopTaskHistoryMapper.deleteByIds(idList);

		baseResponse.setCode(StatuConstant.SUCCESS_CODE);
		baseResponse.setMessage("删除成功");

		return baseResponse;
	}

	/**
	 *批量软删除
	 */
	@Override
	@Transactional(rollbackFor=Exception.class)
	public BaseResponse softDeleteByIds(List<Integer> idList, HttpServletRequest httpRequest) throws Exception {
		BaseResponse baseResponse = new BaseResponse();

		dmpDevelopTaskHistoryMapper.softDeleteByIds(idList);

		baseResponse.setCode(StatuConstant.SUCCESS_CODE);
		baseResponse.setMessage("软删除成功");

		return baseResponse;
	}

	/**
	 *任务版本回滚
	 */
	@Override
	public BaseResponse taskVersionRollback(Integer id, HttpServletRequest httpRequest)
			throws Exception {
		BaseResponse baseResponse = new BaseResponse();
		
		DmpDevelopTaskHistoryDto dmpDevelopTaskHistoryDto = dmpDevelopTaskHistoryMapper.findById(id);
		if (dmpDevelopTaskHistoryDto==null) {
			baseResponse.setCode(StatuConstant.CODE_DATA_NOTMEET);
			baseResponse.setMessage("版本数据不存在！");
			return baseResponse;
		}
		
		DmpDevelopTask dmpDevelopTask = MyDmpDevelopTaskHistoryConverter.INSTANCE().historyDto2task(dmpDevelopTaskHistoryDto);
		
		FlowPro flowPro = MyDmpDevelopTaskConverter.INSTANCE().task2flowpro(dmpDevelopTask);
		
		//重新发布到azkaban
		BaseResponse baseResponsePublish = flowService.publishFlow(flowPro);
        if (StatuConstant.SUCCESS_CODE.equals(baseResponsePublish.getCode())) {
            flowPro.setIsSubmit("1");
            //保存流程数据
            //修改task表中任务信息
            DmpDevelopTask queryDmpDevelopTask = dmpDevelopTaskDao.get(flowPro.getTreeId());

            DmpDevelopTask updateDevelopTask = new DmpDevelopTask();
            updateDevelopTask.setId(queryDmpDevelopTask.getId());

            try {
                updateDevelopTask.setFlowJson(flowPro.getFlowJson());
                updateDevelopTask.setData(GZIPUtils.gzipString(flowPro.getFlowJson(), "utf-8"));
            } catch (IOException e) {
                e.printStackTrace();
            }
            updateDevelopTask.setIsSubmit(flowPro.getIsSubmit());
            updateDevelopTask.setIsGziped(1);
            dmpDevelopTaskDao.update(updateDevelopTask);
            
        }
        
        baseResponse.setCode(StatuConstant.SUCCESS_CODE);
        baseResponse.setMessage("任务版本切换保存发布成功");
        
		return baseResponse;
	}

}
