package com.jz.dmp.modules.service.projconfig;

import java.util.List;
import javax.servlet.http.HttpServletRequest;
import com.jz.common.bean.BaseBeanResponse;
import com.jz.common.bean.BaseResponse;
import com.jz.common.bean.PageInfoResponse;
import com.jz.dmp.modules.controller.projconfig.bean.DmpProjectConfigInfoBatch;
import com.jz.dmp.modules.controller.projconfig.bean.DmpProjectConfigInfoDto;
import com.jz.dmp.modules.controller.projconfig.bean.DmpProjectConfigInfoRequest;
import com.jz.dmp.modules.model.DmpProjectConfigInfo;

/**
 * 项目配置表服务接口
 * @author ybz
 *
 */
public interface DmpProjectConfigInfoService {

	/**条件分頁查询所有项目配置表
	 * @param dmpProjectConfigInfoRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public PageInfoResponse<DmpProjectConfigInfoDto> findListWithPage(DmpProjectConfigInfoRequest dmpProjectConfigInfoRequest, HttpServletRequest httpRequest)throws Exception;
	
	/**条件查询所有项目配置表
	 * @param dmpProjectConfigInfoRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpProjectConfigInfoDto> findList(DmpProjectConfigInfoRequest dmpProjectConfigInfoRequest, HttpServletRequest httpRequest)throws Exception;

	

	/**新增项目配置表
	 * @param dmpProjectConfigInfo
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpProjectConfigInfo> add(DmpProjectConfigInfo dmpProjectConfigInfo, HttpServletRequest httpRequest)throws Exception;
	
	/**主键查询项目配置表
	 * @param projectConfigId
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpProjectConfigInfoDto> findById(Integer projectConfigId, HttpServletRequest httpRequest)throws Exception;

	/**修改项目配置表
	 * @param dmpProjectConfigInfo
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpProjectConfigInfo> edit(DmpProjectConfigInfo dmpProjectConfigInfo, HttpServletRequest httpRequest)throws Exception;
	
	/**新增或修改项目配置表
	 * @param dmpProjectConfigInfo
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpProjectConfigInfo> addOrEdit(DmpProjectConfigInfo dmpProjectConfigInfo, HttpServletRequest httpRequest)throws Exception;


	/**主键删除项目配置表
	 * @param projectConfigId
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse deleteById(Integer projectConfigId, HttpServletRequest httpRequest)throws Exception;
	
	/**主键软删除项目配置表
	 * @param projectConfigId
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse softDeleteById(Integer projectConfigId, HttpServletRequest httpRequest)throws Exception;
	
	/**条件删除项目配置表
	 * @param dmpProjectConfigInfoRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse delete(DmpProjectConfigInfoRequest dmpProjectConfigInfoRequest, HttpServletRequest httpRequest)throws Exception;
	
	/**条件软删除项目配置表
	 * @param dmpProjectConfigInfoRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse softDelete(DmpProjectConfigInfoRequest dmpProjectConfigInfoRequest, HttpServletRequest httpRequest)throws Exception;

	/**批量新增项目配置表
	 * @param dmpProjectConfigInfoVo
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpProjectConfigInfoBatch> addBatch(DmpProjectConfigInfoBatch dmpProjectConfigInfoBatch, HttpServletRequest httpRequest)throws Exception;

	/**  
	* @Title: deleteByIds  
	* @Description: TODO(根据主键批量删除)  
	* @param @param idList
	* @param @param httpRequest
	* @param @return
	* @param @throws Exception    参数  
	* @return BaseResponse    返回类型  
	* @throws  
	*/ 
	public BaseResponse deleteByIds(List<Integer> idList, HttpServletRequest httpRequest)throws Exception;

	/**  
	* @Title: softDeleteByIds  
	* @Description: TODO(根据主键批量软删除)  
	* @param @param idList
	* @param @param httpRequest
	* @param @return
	* @param @throws Exception    参数  
	* @return BaseResponse    返回类型  
	* @throws  
	*/ 
	public BaseResponse softDeleteByIds(List<Integer> idList, HttpServletRequest httpRequest)throws Exception;

	/**  
	* @Title: findByProjectId  
	* @Description: TODO(获取项目配置信息)  
	* @param @param projectId
	* @param @param httpRequest
	* @param @return
	* @param @throws Exception    参数  
	* @return BaseBeanResponse<DmpProjectConfigInfoDto>    返回类型  
	* @throws  
	*/ 
	public BaseBeanResponse<DmpProjectConfigInfoDto> findByProjectId(Integer projectId, HttpServletRequest httpRequest)throws Exception;

}
